#ifndef Model_c
#define NN        9	/* number of vertices -> look at "e_cell" !!! */
#define EVec	 C9	/* see list of EdgeVectors row=36ff  */
#define Title   "N=9 triangular lattice"
#define Sym       8	/* x x 7 x x x x x x Symmetrien */
#define Sud       1
#define CM(JJ,tJ,tU) tJ	/* Heisenberg-,  t-J- or  Hubbard-model */

#define Nw 	(3*NN)	/* (3*NN):J1, (6*NN):J1-J2 */
#define Ne NN
#define noSBase 1	/* SBase/noSBase = with/without symmetry */ 
#endif

int site_move(int i,int dx,int dy,int dz,...);	/* declaration */
#define SITE_DIST 1
int site_dist(int i,int j);	/* declaration */
int initvars();

#ifdef Model_c
/* ================== 3D-Gitter nach Betts =========================== */
/* 
   2 ineinandergeschachtelte cubische Gitter mit verdoppelter Einheitszelle
   das 2-te Gitter ist um (1,1,1) verschoben 
   -> utils/cubes.c
   Berechnung kubischer Gitter aus Vektoren die Elementarzelle aufspannen 
   e_cell = elementary cell (a,b,c) most compact form (-> Betts)
 */

/* please take exactly one of the following lines, or add new one 
   linkshaendige edge-vectors, cos=skalarprod=0=90deg, len=LenDiff=a-b=0 
   ==> V%3=0
   ==> 9,12,21,27
   -----name----edge-vectors---------cos-len--remark------------------ */
#define C9	{{ 3, 0},{ 0, 3}}  /* 0  0 */
#define C12	{{ 2,-2},{ 0, 6}}  /* 0  0 */
#define C18	{{ 3,-3},{ 0, 6}}  /* 0  0 */
#define C21	{{ 7,-7},{ 0, 3}}  /* ??? */
#define C24	{{ 4,-4},{ 0, 6}}  /* ??? */
#define C27	{{ 3,-3},{ 0, 9}}  /* 0  0 */

int e_cell[2][2]=EVec;	/* defined higher (one from upper list) */

int vertex[NN][2];              /* position of vertizees */         

/*   analog square lattice mit nur 1em J2 als drittes J1

       | / | / | /     \ / \ / \ / 
      -6---7---8--     -7---8---6--
       | / | / | /     / \ / \ / \ 
      -3---4---5--     ---4---5---3
       | / | / | /     \ / \ / \ / 
      -0---1---2--     -0---1---2--
 */

/* vertex -> (x,y) */
int get_koord(const int i,int s[2]){
  if(i<0 || i>=NN) { printf("error: get_koord\n"); return -1; }
  s[0]=vertex[i][0];
  s[1]=vertex[i][1];
  return 0;}
  
/* (x,y,z) -> vertex */  
int get_vertex(int xx[2],int dx,int dy,int dz){
  int i,x[2],(*e)[2]=e_cell,aa,ab,bb,ar,br,ra,rb,det,(*s)[2]=vertex;
  x[0]=xx[0]+dx;x[1]=xx[1]+dy;if(dz!=0)E0("dz!=0");
  aa=e[0][0]*e[0][0]+e[0][1]*e[0][1];
  ab=e[0][0]*e[1][0]+e[0][1]*e[1][1];
  bb=e[1][0]*e[1][0]+e[1][1]*e[1][1];
  det= bb*aa - ab*ab;
  ar=e[0][0]*x[0]   +e[0][1]*x[1] ;
  br=e[1][0]*x[0]   +e[1][1]*x[1] ;
  ra= ( + bb*ar - ab*br );
  rb=-( + ab*ar - aa*br );
  if(ra<0)ra=-((-ra-1)/det)-1;else ra/=det;
  if(rb<0)rb=-((-rb-1)/det)-1;else rb/=det;
  x[0]-=ra*e[0][0]+rb*e[1][0];
  x[1]-=ra*e[0][1]+rb*e[1][1];
  for(i=0;i<NN;i++) 
    if(x[0]==s[i][0] && x[1]==s[i][1]) return i;
#if 0
  printf("error get_vertex: %2d %2d -(%2d %2d)-> %2d %2d not found\n",
    xx[0]+dx,xx[1]+dy,ra,rb,x[0],x[1]);
#endif
  return -1;}

int vertex_init(){ /* vertex_init */
   int i,j,k,r[2],ra,rb,aa,ab,bb,ar,br,det,emin[2],emax[2],
     (*s)[2]=vertex; const int (*e)[2]=e_cell /* ,*a=e[0],*b=e[1] */ ;
   /* plaetze finden! */
   
   for(i=0;i<2;i++)printf(" %c=(%2d %2d)",'a'+i,e[i][0],e[i][1]);
   i=( e[0][0]*e[1][1]     /*   ax by */ 
      -e[0][1]*e[1][0] );  /* - ay bx */
   printf("  NN=%d == volume=Det(l)=%d\n",NN, i);
   if(abs(i)!=NN) F0("confusion in cluster size");
   
   /* einhuellenden Kubus ermitteln (alle eck-koords checken) */
   for(i=0;i<2;i++){ 
     emin[i]=emax[i]=e[0][i]+e[1][i]; 
     if(emin[i]>0)emin[i]=0;
     if(emax[i]<0)emax[i]=0;
     for(j=0;j<2;j++){
       if(e[j][i]<emin[i])emin[i]=e[j][i];
       if(e[j][i]>emax[i])emax[i]=e[j][i];
       for(k=j+1;k<2;k++){
         if(e[j][i]+e[k][i]<emin[i])emin[i]=e[j][i]+e[k][i];
         if(e[j][i]+e[k][i]>emax[i])emax[i]=e[j][i]+e[k][i];
   }}}
   printf("emin=(%d %d) emax=(%d %d)\n",
   emin[0],emin[1],emax[0],emax[1]);
   
   i=0;
   aa=e[0][0]*e[0][0]+e[0][1]*e[0][1];
   ab=e[0][0]*e[1][0]+e[0][1]*e[1][1];
   bb=e[1][0]*e[1][0]+e[1][1]*e[1][1];
   det= bb*aa - ab*ab;

   /* sublattice A */
   for(r[0]=emin[0];r[0]<=emax[0];r[0]+=1)
   for(r[1]=emin[1];r[1]<=emax[1];r[1]+=1){  /* ineffektiv! */
    ar=e[0][0]*r[0]   +e[0][1]*r[1] ;
    br=e[1][0]*r[0]   +e[1][1]*r[1] ;
    ra= ( + bb*ar - ab*br );
    rb=-( + ab*ar - aa*br );
#if 0
    printf(" r=(%2d %2d) det^2(ra rb)=(%4d %4d)",r[0],r[1],ra,rb);
    printf(" ra*a+rb*b=(%2d %2d)", (ra*e[0][0]+rb*e[1][0])/det,
        			   (ra*e[0][1]+rb*e[1][1])/det );
    if(ra>=0 && rb>=0 && ra<det && rb<det) printf(" i=%3d", i);printf("\n");
#endif
    if(ra>=0 && rb>=0 && ra<det && rb<det){
      pos[i][0]=s[i][0]=r[0];		/* pos declared in spins.h */
      pos[i][1]=s[i][1]=r[1]; i++; }
   }
   
   if(i!=NN)printf("error vertex_init i!=N i=%d N=%d\n",i,NN);

   return 0;
}


  /*  i=site 0..NN, d=direction 0..2, s=steps ..,-1,0,1,.. rc=i+s*vec_d */
  /* besser site(i,dx,dy[,dz])  dy<0 geht nicht !!!!  */
  int site_move(int i,int dx,int dy,int dz,...){ int r[2];
    if(i<0 || i>=NN)return -1;
    get_koord(i,r);
    i=get_vertex(r,dx,dy,dz);
    return(i);}

  /* Abstandsdefinition (z.B.) fuer Untergittermagnetisierung */
  int site_dist(int i,int j){ /* Abstandsdefinition: |dx|+|dy|+|dz| */
     int ri[2],rj[2];
     get_koord(i,ri);
     get_koord(j,rj);
     return(abs(ri[0]-rj[0])+abs(ri[1]-rj[1]));}

  int initvars(){
    int i; 
    nu=NN/2;nd=NN/2+NN%2;
    vertex_init();
#define Bd(l,a,b) for(i=0;i<NN;i++){ iw[l][0]=a; iw[l][1]=b; }
    Bd(i     ,i,site_move(i,1, 0, 0));
    Bd(i+1*NN,i,site_move(i,0, 1, 0));
    Bd(i+2*NN,i,site_move(i,1, 1, 0));
#if Nw>3*NN
    Bd(i+3*NN,i,site_move(i,1,-1, 0));
    Bd(i+3*NN,i,site_move(i,2, 1, 0));
    Bd(i+3*NN,i,site_move(i,1, 2, 0));
#endif
    for(i=0;i< Nw;i++)wj[i]=(i<3*NN)?1:2;
    for(i=0;i< Nw;i++)wt[i]= 2;
    for(i=0;i< NN;i++)we[i]= 3;
    for(i=0;i< NN;i++)wu[i]= 4;
    numpara=CM(3,3,5);
    para[0]= 0.0;	/* immer 0 */
    para[1]= 1.0;	/* J1 */
    para[2]=-1.0;	/* t1/J2 */
    para[3]= 0.0;	/* e */
    para[4]= 8.0;	/* U */
    return 0;}    
#endif

